tests: allow '.write' to be directories
[nit.git] / tests / tests.sh
index 607b690..8c00881 100755 (executable)
@@ -17,8 +17,8 @@
 
 # This shell script compile, run and verify Nit program files
 
-# The default nitc compiler
-[ -z "$NITC" ] && NITC=../bin/nitc
+# Set lang do default to avoid failed tests because of locale
+export LANG=C
 
 usage()
 {
@@ -31,6 +31,67 @@ Usage: $e [options] modulenames
 END
 }
 
+# As argument: the pattern used for the file
+function process_result()
+{
+       # Result
+       pattern=$1
+       SAV=""
+       FAIL=""
+       if [ -r "sav/$pattern.sav" ]; then
+               diff -u "$pattern.res" "sav/$pattern.sav" > "$pattern.diff.sav.log"
+               if [ "$?" == 0 ]; then
+                       SAV=OK
+               else
+                       SAV=NOK
+               fi
+       fi
+       if [ -r "sav/$pattern.fail" ]; then
+               diff -u "$pattern.res" "sav/$pattern.fail" > "$pattern.diff.fail.log"
+               if [ "$?" == 0 ]; then
+                       FAIL=OK
+               else
+                       FAIL=NOK
+               fi
+       fi
+       if [ "x$SAV" = "xOK" ]; then
+               if [ "x$FAIL" = "x" ]; then
+                       echo "[ok] $pattern.res"
+               else
+                       echo "[ok] $pattern.res - but sav/$pattern.fail remains!"
+               fi
+               ok="$ok $pattern"
+       elif [ "x$FAIL" = "xOK" ]; then
+               echo "[fail] $pattern.res"
+               ok="$ok $pattern"
+       elif [ "x$SAV" = "xNOK" ]; then
+               echo "[======= fail $pattern.res sav/$pattern.sav =======]"
+               nok="$nok $ff"
+               echo "$ii" >> "$ERRLIST"
+       elif [ "x$FAIL" = "xNOK" ]; then
+               echo "[======= changed $pattern.res sav/$pattern.fail ======]"
+               nok="$nok $ff"
+               echo "$ii" >> "$ERRLIST"
+       else
+               echo "[=== no sav ===] $pattern.res"
+               nos="$nos $pattern"
+       fi
+}
+
+find_nitc()
+{
+       recent=`ls -t ../src/nitc ../src/nitc_[0-9] ../bin/nitc ../c_src/nitc 2>/dev/null | head -1`
+       if [[ "x$recent" == "x" ]]; then
+               echo 'Could not find nitc, aborting'
+               exit 1
+       fi
+       echo 'Using nitc from: '$recent
+       NITC=$recent
+}
+
+# The default nitc compiler
+[ -z "$NITC" ] && find_nitc
+
 verbose=false
 stop=false
 while [ $stop = false ]; do
@@ -48,19 +109,18 @@ done
 # File where error tests are outputed
 # Old ERRLIST is backuped
 ERRLIST=${ERRLIST:-errlist}
+ERRLIST_TARGET=$ERRLIST
 
 if [ $# = 0 ]; then
        usage;
        exit
 fi
 
-# Backup and initiate new ERRLIST
+# Initiate new ERRLIST
 if [ "x$ERRLIST" = "x" ]; then
        ERRLIST=/dev=null
 else
-       if [ -x "$ERRLIST" ]; then
-               mv "$ERRLIST" "${ERRLIST}.bak"
-       fi
+       ERRLIST=$ERRLIST.tmp
        > "$ERRLIST"
 fi
 
@@ -68,6 +128,10 @@ ok=""
 nok=""
 
 for ii in "$@"; do
+       if [ ! -f $ii ]; then
+               echo "File '$ii' does not exist."
+               continue
+       fi
        for alt in "" `sed -n 's/.*#!*\(alt[0-9]*\)#.*/\1/p' "$ii" | sort -u`; do
                f=`basename "$ii" .nit`
                d=`dirname "$ii"`
@@ -83,32 +147,28 @@ for ii in "$@"; do
 
                echo -n "=> $i: "
 
-               rm "$ff.res" "$ff.err" "$ff.write" 2> /dev/null
+               rm -rf "$ff.res" "$ff.err" "$ff.write" "$ff.bin" 2> /dev/null
 
                # Compile
                if [ "x$verbose" = "xtrue" ]; then
                        echo ""
-                       echo $NITC $OPT -o "$f.bin" "$i" -I . -I alt -I ../lib/standard
+                       echo $NITC $OPT -o "$ff.bin" "$i" -I . -I alt -I ../lib/standard
                fi
-               $NITC $OPT -o "$f.bin" "$i" -I . -I alt -I ../lib/standard 2> "$ff.cmp.err" > "$ff.compile.log"
+               $NITC $OPT -o "$ff.bin" "$i" -I . -I alt -I ../lib/standard 2> "$ff.cmp.err" > "$ff.compile.log"
                ERR=$?
                if [ "x$verbose" = "xtrue" ]; then
                        cat "$ff.compile.log"
                        cat >&2 "$ff.cmp.err"
                fi
-               mv "$f.bin" "$ff.bin" 2> /dev/null
                egrep '^[A-Z0-9_]*$' "$ff.compile.log" > "$ff.res"
                if [ "$ERR" != 0 ]; then
                        echo -n "! "
                        cp "$ff.cmp.err" "$ff.res"
-               else
+                       process_result $ff
+               elif [ -x "./$ff.bin" ]; then
                        echo -n ". "
                        # Execute
-                       if [ -f "$f.args" ]; then
-                               args=`cat "$f.args"`
-                       else
-                               args=""
-                       fi
+                       args=""
                        if [ "x$verbose" = "xtrue" ]; then
                                echo ""
                                echo "./$ff.bin" $args
@@ -124,52 +184,51 @@ for ii in "$@"; do
                        fi
                        if [ -f "$ff.write" ]; then
                                cat "$ff.write" >> "$ff.res"
+                       elif [ -d "$ff.write" ]; then
+                               ls -F $ff.write >> "$ff.res"
                        fi
                        if [ -s "$ff.err" ]; then
                                cat "$ff.err" >> "$ff.res"
                        fi
-               fi
+                       process_result $ff
 
-               # Result
-               SAV=""
-               FAIL=""
-               if [ -r "sav/$ff.sav" ]; then
-                       diff -u "$ff.res" "sav/$ff.sav" > "$ff.diff.sav.log"
-                       if [ "$?" == 0 ]; then
-                               SAV=OK
-                       else
-                               SAV=NOK
-                       fi
-               fi
-               if [ -r "sav/$ff.fail" ]; then
-                       diff -u "$ff.res" "sav/$ff.fail" > "$ff.diff.fail.log"
-                       if [ "$?" == 0 ]; then
-                               FAIL=OK
-                       else
-                               FAIL=NOK
-                       fi
-               fi
-               if [ "x$SAV" = "xOK" ]; then
-                       if [ "x$FAIL" = "x" ]; then
-                               echo "[ok] $ff.res"
-                       else
-                               echo "[ok] $ff.res - but sav/$ff.fail remains!"
+                       if [ -f "$f.args" ]; then
+                               fargs=$f.args
+                               cptr=0
+                               cat $fargs |
+                               while read line; do
+                                       ((cptr=cptr+1))
+                                       args=$line
+                                       fff=$ff"_args"$cptr
+                                       if [ "x$verbose" = "xtrue" ]; then
+                                               echo ""
+                                               echo "./$ff.bin" $args
+                                       fi
+                                       echo -n "==> args #"$cptr " "
+                                       if [ -f "$f.inputs" ]; then
+                                               "./$ff.bin" $args < "$f.inputs" > "$fff.res" 2>"$fff.err"
+                                       else
+                                               sh -c "./$ff.bin  ''$args > $fff.res 2>$fff.err"
+                                       fi
+                                       if [ "x$verbose" = "xtrue" ]; then
+                                               cat "$fff.res"
+                                               cat >&2 "$fff.err"
+                                       fi
+                                       if [ -f "$fff.write" ]; then
+                                               cat "$fff.write" >> "$fff.res"
+                                       elif [ -d "$fff.write" ]; then
+                                               ls -F $fff.write >> "$fff.res"
+                                       fi
+                                       if [ -s "$fff.err" ]; then
+                                               cat "$fff.err" >> "$fff.res"
+                                       fi
+                                       process_result $fff
+                               done
                        fi
-                       ok="$ok $ff"
-               elif [ "x$FAIL" = "xOK" ]; then
-                       echo "[fail] $ff.res"
-                       ok="$ok $ff"
-               elif [ "x$SAV" = "xNOK" ]; then
-                       echo "[======= fail $ff.res sav/$ff.sav =======]"
-                       nok="$nok $ff"
-                       echo "$ii" >> "$ERRLIST"
-               elif [ "x$FAIL" = "xNOK" ]; then
-                       echo "[======= changed $ff.res sav/$ff.fail ======]"
-                       nok="$nok $ff"
-                       echo "$ii" >> "$ERRLIST"
                else
-                       echo "[=== no sav ===] $ff.res"
-                       nos="$nos $ff"
+                       echo -n "! "
+                       echo "Compilation error" > "$ff.res"
+                       process_result $ff
                fi
        done
 done
@@ -178,12 +237,20 @@ echo "ok: " `echo $ok | wc -w` "/" `echo $ok $nok $nos | wc -w`
 
 if [ -n "$nok" ]; then
        echo "fail: $nok"
-       echo "There were errors ! (see file $ERRLIST)"
+       echo "There were $(echo $nok | wc -w) errors ! (see file $ERRLIST)"
 fi
 if [ -n "$nos" ]; then
        echo "no sav: $nos"
 fi
 
+# write $ERRLIST
+if [ "x$ERRLIST" != "x" ]; then
+       if [ -x "$ERRLIST_TARGET" ]; then
+               mv "$ERRLIST_TARGET" "${ERRLIST_TARGET}.bak"
+       fi
+       mv $ERRLIST $ERRLIST_TARGET
+fi
+
 if [ -n "$nok" ]; then
        exit 1
 else